(function(im){
	var appKey = "sfci50a7s34ci";
	im.init = function(connectionStatusListener, receiveMessageListener) {
		var RongIMClient = RongIMLib.RongIMClient;
		var config = {};
		/*
		重新部署后替换为新路径
		路径格式说明：不带http(s)://，为了自动从页面继承协议方便
		*/
		//config.protobuf =  baseURL+"/component/im/protobuf-2.3.1.min.js",
		
		//私有云导航地址参数
		//config.navi =  ""; 
		//初始化
		RongIMClient.init(appKey,null,config);
		// 连接状态监听器
		RongIMClient.setConnectionStatusListener({
			onChanged: function (status) {
				console.info(status)
			    switch (status) {
			        case RongIMLib.ConnectionStatus.CONNECTED:
			            showInfo("链接成功");
			            console.log('链接成功');
			            // afterConnected();
			            break;
			        case RongIMLib.ConnectionStatus.CONNECTING:
			            console.log('正在链接');
			            break;
			        case RongIMLib.ConnectionStatus.DISCONNECTED:
			            console.log('断开连接');
			            break;
			        case RongIMLib.ConnectionStatus.KICKED_OFFLINE_BY_OTHER_CLIENT:
			            console.log('其他设备登录');
			            break;
			          case RongIMLib.ConnectionStatus.DOMAIN_INCORRECT:
			            console.log('域名不正确');
			            break;
			        case RongIMLib.ConnectionStatus.NETWORK_UNAVAILABLE:
			        	console.log('网络不可用');
			        	break;
			        }
				connectionStatusListener && connectionStatusListener(status);
			}
		});
		
		RongIMClient.setOnReceiveMessageListener({
			// 接收到的消息
			onReceived: function (message) {
			    // 判断消息类型
			    // showTips("新消息，类型为：" + message.messageType);
	            // showResult("新消息",message,start);
	            console.log(message)
			    switch(message.messageType){
			        case RongIMClient.MessageType.TextMessage:
			        	receiveMessageListener && receiveMessageListener(message.content.content);
			        	/*
			        	显示消息方法： 
			        	消息里是 原生emoji
			        	RongIMLib.RongIMEmoji.emojiToHTML(message.content.content);
			            */
			            break;
			        case RongIMClient.MessageType.VoiceMessage:
			            // 对声音进行预加载                
			            // message.content.content 格式为 AMR 格式的 base64 码
			            break;
			        case RongIMClient.MessageType.ImageMessage:
			           // message.content.content => 图片缩略图 base64。
			           // message.content.imageUri => 原图 URL。
			           break;
			        case RongIMClient.MessageType.DiscussionNotificationMessage:
			           // message.content.extension => 讨论组中的人员。
			           break;
			        case RongIMClient.MessageType.LocationMessage:
			           // message.content.latiude => 纬度。
			           // message.content.longitude => 经度。
			           // message.content.content => 位置图片 base64。
			           break;
			        case RongIMClient.MessageType.RichContentMessage:
			           // message.content.content => 文本消息内容。
			           // message.content.imageUri => 图片 base64。
			           // message.content.url => 原图 URL。
			           break;
			        case RongIMClient.MessageType.InformationNotificationMessage:
			            // do something...
			           break;
			        case RongIMClient.MessageType.ContactNotificationMessage:
			            // do something...
			           break;
			        case RongIMClient.MessageType.ProfileNotificationMessage:
			            // do something...
			           break;
			        case RongIMClient.MessageType.CommandNotificationMessage:
			            // do something...
			           break;
			        case RongIMClient.MessageType.CommandMessage:
			            // do something...
			           break;
			        case RongIMClient.MessageType.UnknownMessage:
			            // do something...
			           break;
			        default:
			            // do something...
			    }
			}
		});
	};
	
	var defaultCallbacks = {};
	im.login = function(token, callbacks) {
		callbacks || (callbacks = defaultCallbacks);
		// 连接融云服务器。
      	RongIMClient.connect(token, {
	        onSuccess: function(userId) {
	          console.log("用户登录成功.");
	          if (callbacks.onSuccess)
	          	callbacks.onSuccess.call();
	        },
	        onTokenIncorrect: function() {
	          console.log('无效的token');
	           if (callbacks.onTokenIncorrect)
	          	callbacks.onSuccess.call();
	        },
	        onError:function(errorCode){
	            var info = '';
	            switch (errorCode) {
	                case RongIMLib.ErrorCode.TIMEOUT:
	                  info = '超时';
	                  break;
	                case RongIMLib.ErrorCode.UNKNOWN_ERROR:
	                  info = '未知错误';
	                  break;
	                case RongIMLib.ErrorCode.UNACCEPTABLE_PaROTOCOL_VERSION:
	                  info = '不可接受的协议版本';
	                  break;
	                case RongIMLib.ErrorCode.IDENTIFIER_REJECTED:
	                  info = 'appkey不正确';
	                  break;
	                case RongIMLib.ErrorCode.SERVER_UNAVAILABLE:
	                  info = '服务器不可用';
	                  break;
	           	}
	            console.log(errorCode);
	            if (callbacks.onError)
	          		callbacks.onError.call();
	        }
      	});
	}
	
	im.sendMessage = function(_targetId, _message, callbacks) {
		callbacks || (callbacks = defaultCallbacks);
		// 定义消息类型,文字消息使用 RongIMLib.TextMessage
		var msg = new RongIMLib.TextMessage({
			content: _message,
			extra: "© badousoft"
		});
		//或者使用RongIMLib.TextMessage.obtain 方法.具体使用请参见文档
		var conversationtype = RongIMLib.ConversationType.PRIVATE; // 私聊
		var targetId = _targetId; // 目标 Id
		RongIMClient.getInstance().sendMessage(conversationtype, targetId, msg, {
			// 发送消息成功
			onSuccess: function(message) {
				//message 为发送的消息对象并且包含服务器返回的消息唯一Id和发送消息时间戳
				console.log("消息发送成功");
				 if (callbacks.onSuccess)
	          		callbacks.onSuccess.call();
			},
			onError: function(errorCode, message) {
				var info = '';
				switch (errorCode) {
					case RongIMLib.ErrorCode.TIMEOUT:
						info = '超时';
						break;
					case RongIMLib.ErrorCode.UNKNOWN_ERROR:
						info = '未知错误';
						break;
					case RongIMLib.ErrorCode.REJECTED_BY_BLACKLIST:
						info = '在黑名单中，无法向对方发送消息';
						break;
					case RongIMLib.ErrorCode.NOT_IN_DISCUSSION:
						info = '不在讨论组中';
						break;
					case RongIMLib.ErrorCode.NOT_IN_GROUP:
						info = '不在群组中';
						break;
					case RongIMLib.ErrorCode.NOT_IN_CHATROOM:
						info = '不在聊天室中';
						break;
					default:
						info = x;
						break;
				}
				console.log('发送失败:' + info);
				if (callbacks.onError)
	          		callbacks.onError.call();
			}
		});
	};
	
	/**
	 * @param {Object} _targetToken 用户token
	 * @param {Object} _onSuccess _onSuccess(hasMessage), hasMessage为boolean值表示，是否有未读消息
	 * @param {Object} _onError 错误处理
	 */
	im.hasRemoteUnreadMessages = function(_targetToken, _onSuccess, _onError) {
		RongIMClient.getInstance().hasRemoteUnreadMessages('mKmyKqTSf7aNDinwAFMnz7NXKILeV3X0+CCRBOxmtOApmvQjMathViWrePIfq0GuTu9jELQqsckv4AhfjCAKgQ==',{
		    onSuccess:function(hasMessage){
		        _onSuccess.call(hasMessage);
		    },onError:function(err){
		    	_onError.call();
		    }
		});
	}
	
}(window.webIM = {}));
